/**
 * @param {App.Entity.SlaveState} heroSlave
 * @param {App.Entity.SlaveState} baseHeroSlave
 * @return {App.Entity.SlaveState}
 */
App.Utils.getHeroSlave = function(heroSlave, baseHeroSlave) {
	function isObject(o) {
		return (o !== undefined && typeof o === 'object' && !Array.isArray(o));
	}

	function deepAssign(target, source) {
		if (isObject(target) && isObject(source)) {
			for (const key in source) {
				if (!source.hasOwnProperty(key)) { continue; }
				if (isObject(source[key])) {
					if (!target.hasOwnProperty(key)) { target[key] = {}; }
					deepAssign(target[key], source[key]);
				} else {
					Object.assign(target, {
						[key]: source[key]
					});
				}
			}
		}
	}
	const newSlave = clone(baseHeroSlave);
	deepAssign(newSlave, heroSlave);
	generatePuberty(newSlave);
	return newSlave;
};
